import { ShaderArtPlugin } from '@shader-art/plugin-base';
export declare type PointerEventSubscriber = (x: number, y: number, dragging: boolean) => void;
export declare class PointerInteractionsPlugin implements ShaderArtPlugin {
    name: string;
    initialized: boolean;
    hostElement: HTMLElement | null;
    gl: WebGLRenderingContext | WebGL2RenderingContext | null;
    program: WebGLProgram | null;
    canvas: HTMLCanvasElement | null;
    startX: number;
    startY: number;
    dragging: boolean;
    pointerId: number;
    subscribers: PointerEventSubscriber[];
    setup(hostElement: HTMLElement, gl: WebGLRenderingContext | WebGL2RenderingContext, program: WebGLProgram, canvas: HTMLCanvasElement): void;
    subscribe(func: PointerEventSubscriber): PointerInteractionsPlugin;
    onPointerUp: (e: PointerEvent) => void;
    onPointerDown: (e: PointerEvent) => void;
    onPointerMove: (e: PointerEvent) => void;
    private notifySubscribers;
    dispose(): void;
    private setUniformVec2;
    private setUniformInt;
}
export declare const PointerInteractionsPluginFactory: () => PointerInteractionsPlugin;
